--[[        ]]
--[[ Locals ]]
--[[        ]]

local L                 = AceLibrary("AceLocale-2.2"):new("Vibrant")
local TEST = "TEST"
local Sequence = {
		[1] = nil,
		[2] = nil,
		[3] = nil,
		[4] = nil,
		[5] = nil,
		[6] = nil,
		[7] = nil,
		[8] = nil,
		[9] = nil,
	}


--[[          ]]
--[[ CreateUI ]]
--[[          ]]


function Vibrant:BuildDisplay()

	self.frames = self.frames or {}

	-- Create Main frame
	local main = CreateFrame("Frame", "Main", UIParent)
	self.frames.main = main
	
	-- Create UpGreen button
	local ug = CreateFrame("Button", "UpGreen", self.frames.main)
		ug:SetMovable(false)
		ug:SetPoint("CENTER", UIParent, "CENTER", 0, Vibrant.db.profile.ButtonDistance)
		ug:SetClampedToScreen(true)
		ug:EnableMouse(true)
		ug:SetScript("OnEnter", function () self.frames.main.upgreen.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\green_on") end)
		ug:SetScript("OnLeave", function () self.frames.main.upgreen.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\green_off") end)
	self.frames.main.upgreen = ug
	
	local ugtexture = self.frames.main.upgreen:CreateTexture(nil, "LOW")
		ugtexture:SetAllPoints(ug)
	self.frames.main.upgreen.texture = ugtexture
	
	-- Create RightYellow button
	local ry = CreateFrame("Button", "RightYellow", self.frames.main)
		ry:SetMovable(false)
		ry:SetPoint("CENTER", UIParent, "CENTER", Vibrant.db.profile.ButtonDistance, 0)
		ry:SetClampedToScreen(true)
		-- hopefully this will stop the frame from capturing mouse clicks
		ry:EnableMouse(true)
		ry:SetScript("OnEnter", function () self.frames.main.rightyellow.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\yellow_on") end)
		ry:SetScript("OnLeave", function () self.frames.main.rightyellow.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\yellow_off") end)
	self.frames.main.rightyellow = ry
	
	local rytexture = self.frames.main.rightyellow:CreateTexture(nil, "LOW")
		rytexture:SetAllPoints(ry)
	self.frames.main.rightyellow.texture = rytexture

	-- Create DownBlue button
	local db = CreateFrame("Button", "DownBlue", self.frames.main)
		db:SetMovable(false)
		db:SetPoint("CENTER", UIParent, "CENTER", 0, -Vibrant.db.profile.ButtonDistance)
		db:SetClampedToScreen(true)
		-- hopefully this will stop the frame from capturing mouse clicks
		db:EnableMouse(true)
		db:SetScript("OnEnter", function () self.frames.main.downblue.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\blue_on") end)
		db:SetScript("OnLeave", function () self.frames.main.downblue.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\blue_off") end)
	self.frames.main.downblue = db
	
	local dbtexture = self.frames.main.downblue:CreateTexture(nil, "LOW")
		dbtexture:SetAllPoints(db)
	self.frames.main.downblue.texture = dbtexture
	
	-- Create LeftRed button
	local lr = CreateFrame("Button", "LeftRed", self.frames.main)
		lr:SetMovable(false)
		lr:SetPoint("CENTER", UIParent, "CENTER", -Vibrant.db.profile.ButtonDistance, 0)
		lr:SetClampedToScreen(true)
		-- hopefully this will stop the frame from capturing mouse clicks
		lr:EnableMouse(true)
		lr:SetScript("OnEnter", function () self.frames.main.leftred.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\red_on") end)
		lr:SetScript("OnLeave", function () self.frames.main.leftred.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\red_off") end)
	self.frames.main.leftred = lr
	
	local lrtexture = self.frames.main.leftred:CreateTexture(nil, "LOW")
		lrtexture:SetAllPoints(lr)
	self.frames.main.leftred.texture = lrtexture

	-- Create PlayBtn button
	local play = CreateFrame("Button", "PlayBtn", self.frames.main)
		play:SetMovable(false)
		play:SetPoint("CENTER", UIParent, "CENTER", 0, 16)
		play:SetClampedToScreen(true)
		-- hopefully this will stop the frame from capturing mouse clicks
		play:EnableMouse(true)
		play:SetScript("OnEnter", function () self.frames.main.playbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\play_on") end)
		play:SetScript("OnLeave", function () self.frames.main.playbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\play_off") end)
	self.frames.main.playbtn = play
	
	local playtexture = self.frames.main.playbtn:CreateTexture(nil, "LOW")
		playtexture:SetAllPoints(play)
	self.frames.main.playbtn.texture = playtexture

	-- Create DelBtn button
	local del = CreateFrame("Button", "DelBtn", self.frames.main)
		del:SetMovable(false)
		del:SetPoint("CENTER", UIParent, "CENTER", 0, -16)
		del:SetClampedToScreen(true)
		-- hopefully this will stop the frame from capturing mouse clicks
		del:EnableMouse(true)
		del:SetScript("OnEnter", function () self.frames.main.delbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\del_on") end)
		del:SetScript("OnLeave", function () self.frames.main.delbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\del_off") end)
	self.frames.main.delbtn = del
	
	local deltexture = self.frames.main.delbtn:CreateTexture(nil, "LOW")
		deltexture:SetAllPoints(del)
	self.frames.main.delbtn.texture = deltexture
	
	-- Finish setting up our frames
	self:UpdateFrame()

end



--[[             ]]
--[[ UpdateFrame ]]
--[[             ]]

function Vibrant:UpdateFrame()

	-- UpGreen frame
	self.frames.main.upgreen:SetWidth(Vibrant.db.profile.ButtonSize)
	self.frames.main.upgreen:SetHeight(Vibrant.db.profile.ButtonSize)
	self.frames.main.upgreen.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\green_off")
	self.frames.main.upgreen:SetScript("OnClick", self.PressedBtnUG)
	self.frames.main.upgreen:SetPoint("CENTER", UIParent, "CENTER", 0, Vibrant.db.profile.ButtonDistance)

	
	-- RightYellow frame
	self.frames.main.rightyellow:SetWidth(Vibrant.db.profile.ButtonSize)
	self.frames.main.rightyellow:SetHeight(Vibrant.db.profile.ButtonSize)
	self.frames.main.rightyellow.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\yellow_off")
	self.frames.main.rightyellow:SetScript("OnClick", self.PressedBtnRY)
	self.frames.main.rightyellow:SetPoint("CENTER", UIParent, "CENTER", Vibrant.db.profile.ButtonDistance, 0)
	
	-- DownBlue frame
	self.frames.main.downblue:SetWidth(Vibrant.db.profile.ButtonSize)
	self.frames.main.downblue:SetHeight(Vibrant.db.profile.ButtonSize)
	self.frames.main.downblue.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\blue_off")
	self.frames.main.downblue:SetScript("OnClick", self.PressedBtnDB)
	self.frames.main.downblue:SetPoint("CENTER", UIParent, "CENTER", 0, -Vibrant.db.profile.ButtonDistance)
	
	-- LeftRed frame
	self.frames.main.leftred:SetWidth(Vibrant.db.profile.ButtonSize)
	self.frames.main.leftred:SetHeight(Vibrant.db.profile.ButtonSize)
	self.frames.main.leftred.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\red_off")
	self.frames.main.leftred:SetScript("OnClick", self.PressedBtnLR)
	self.frames.main.leftred:SetPoint("CENTER", UIParent, "CENTER", -Vibrant.db.profile.ButtonDistance, 0)
	
	-- PlayBtn frame
	self.frames.main.playbtn:SetWidth(64)
	self.frames.main.playbtn:SetHeight(32)
	self.frames.main.playbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\play_off")
	self.frames.main.playbtn:SetScript("OnClick", self.PressedBtnPlay)
	
	-- DelBtn frame
	self.frames.main.delbtn:SetWidth(64)
	self.frames.main.delbtn:SetHeight(32)
	self.frames.main.delbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\del_off")
	self.frames.main.delbtn:SetScript("OnClick", self.PressedBtnDel)

end


--[[                 ]]
--[[ CheckVisibility ]]
--[[                 ]]

function Vibrant:CheckVisibility()

	if Vibrant.db.profile.ShowUI then
		Vibrant:ShowGUI()
--~ 		Vibrant:Print("Showing UI.")
	else
		Vibrant:HideGUI()
--~ 		Vibrant:Print("Hiding UI.")
	end
end



--[[        ]]
--[[ ShowUI ]]
--[[        ]]

function Vibrant:ShowGUI()
	self.frames.main:Show()
	self:SetIcon("Interface\\AddOns\\Vibrant\\icon")
	self:UpdateTooltip()
end

--[[        ]]
--[[ HideUI ]]
--[[        ]]

function Vibrant:HideGUI()
	self.frames.main:Hide()
	self:SetIcon("Interface\\AddOns\\Vibrant\\icon_off")
	self:UpdateTooltip()
end


--[[              ]]
--[[ PressedBtnUG ]]
--[[              ]]

function Vibrant:PressedBtnUG()
	if Vibrant.db.profile.SoundWhenClick then 
		PlaySoundFile(Vibrant.db.profile.ClickSound);
	end
	
	local i=1
	
	while (Sequence[i] ~= nil) do
--~ 		Vibrant:Print(Sequence[i])
		i=i+1
	end
	Sequence[i]="GREEN"
end


--[[              ]]
--[[ PressedBtnRY ]]
--[[              ]]

function Vibrant:PressedBtnRY()
	if Vibrant.db.profile.SoundWhenClick then 
		PlaySoundFile(Vibrant.db.profile.ClickSound);
	end
	
	local i=1
	
	while (Sequence[i] ~= nil) do
--~ 		Vibrant:Print(Sequence[i])
		i=i+1
	end
	Sequence[i]="YELLOW"
end


--[[              ]]
--[[ PressedBtnDB ]]
--[[              ]]

function Vibrant:PressedBtnDB()
	if Vibrant.db.profile.SoundWhenClick then 
		PlaySoundFile(Vibrant.db.profile.ClickSound);
	end
	
	local i=1
	
	while (Sequence[i] ~= nil) do
--~ 		Vibrant:Print(Sequence[i])
		i=i+1
	end
	Sequence[i]="BLUE"
end


--[[              ]]
--[[ PressedBtnLR ]]
--[[              ]]

function Vibrant:PressedBtnLR()
	if Vibrant.db.profile.SoundWhenClick then 
		PlaySoundFile(Vibrant.db.profile.ClickSound);
	end
	
	local i=1
	
	while (Sequence[i] ~= nil) do
--~ 		Vibrant:Print(Sequence[i])
		i=i+1
	end
	Sequence[i]="RED"
end


--[[                ]]
--[[ PressedBtnPlay ]]
--[[                ]]

function Vibrant:PressedBtnPlay()
	
	if Vibrant.db.profile.SoundWhenClick then 
		PlaySoundFile(Vibrant.db.profile.ClickSound);
	end
	
	local i=1
	
	if (Sequence[i] ~= nil) then
		local timer
		
		Vibrant:ButtonsNotClickable()
		
--~ 		Vibrant:Print("Playing sequence:")
--~ 		Vibrant:Print("Playing sequence.")
		
		while (Sequence[i] ~= nil) do
			timer = (Vibrant.db.profile.InitialPause + (i * Vibrant.db.profile.Pause) + ((i-1) * Vibrant.db.profile.Glowtime))
--~ 			Vibrant:Print(timer)
			Vibrant:ScheduleEvent("Glow"..i, Vibrant.GlowButton, timer, self, Sequence[i])
			
			timer = (Vibrant.db.profile.InitialPause + (i * Vibrant.db.profile.Pause) + (i * Vibrant.db.profile.Glowtime))
--~ 			Vibrant:Print(timer)
			Vibrant:ScheduleEvent("UnGlow"..i, Vibrant.UnGlowButton, timer, self, Sequence[i])
			
			i=i+1
		end
		
		Vibrant:ScheduleEvent("MakeButtonsClickable", Vibrant.ButtonsClickable, timer, self)
		Vibrant:ScheduleEvent("AutoDel", Vibrant.PressedBtnDel, timer, self)
		
	else Vibrant:Print(L["NoSeqRecYet"])
	end
end


--[[               ]]
--[[ PressedBtnDel ]]
--[[               ]]

function Vibrant:PressedBtnDel()
	if Vibrant.db.profile.SoundWhenClick then 
		PlaySoundFile(Vibrant.db.profile.ClickSound);
	end
	
	local i=1
	
--~ 	Vibrant:Print("Deleting sequence:")
--~ 	Vibrant:Print("Deleting sequence.")
	while (Sequence[i] ~= nil) do
--~ 		Vibrant:Print(Sequence[i])
		Sequence[i]=nil
		i=i+1
	end
	
end

--[[            ]]
--[[ GlowButton ]]
--[[            ]]

function Vibrant:GlowButton(color)
	if Vibrant.db.profile.SoundWhenPlay then 
		PlaySoundFile(Vibrant.db.profile.PlaySound);
	end
	
	if color=="GREEN" then
		Vibrant.frames.main.upgreen.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\green_on")
	elseif color=="YELLOW" then
		Vibrant.frames.main.rightyellow.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\yellow_on")
	elseif color=="BLUE" then
		Vibrant.frames.main.downblue.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\blue_on")
	elseif color=="RED" then
		Vibrant.frames.main.leftred.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\red_on")
	end
end


--[[              ]]
--[[ UnGlowButton ]]
--[[              ]]

function Vibrant:UnGlowButton(color)
	if color=="GREEN" then
		Vibrant.frames.main.upgreen.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\green_off")
	elseif color=="YELLOW" then
		Vibrant.frames.main.rightyellow.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\yellow_off")
	elseif color=="BLUE" then
		Vibrant.frames.main.downblue.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\blue_off")
	elseif color=="RED" then
		Vibrant.frames.main.leftred.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\red_off")
	end
end

--[[                     ]]
--[[ ButtonsNotClickable ]]
--[[                     ]]

function Vibrant:ButtonsNotClickable()
	Vibrant.frames.main.upgreen:SetScript("OnClick", nil)
	Vibrant.frames.main.rightyellow:SetScript("OnClick", nil)
	Vibrant.frames.main.downblue:SetScript("OnClick", nil)
	Vibrant.frames.main.leftred:SetScript("OnClick", nil)
	Vibrant.frames.main.playbtn:SetScript("OnClick", nil)
	Vibrant.frames.main.delbtn:SetScript("OnClick", nil)

	Vibrant.frames.main.upgreen:SetScript("OnEnter", nil)
	Vibrant.frames.main.rightyellow:SetScript("OnEnter", nil)
	Vibrant.frames.main.downblue:SetScript("OnEnter", nil)
	Vibrant.frames.main.leftred:SetScript("OnEnter", nil)
	Vibrant.frames.main.playbtn:SetScript("OnEnter", nil)
	Vibrant.frames.main.delbtn:SetScript("OnEnter", nil)

	Vibrant.frames.main.upgreen:SetScript("OnLeave", nil)
	Vibrant.frames.main.rightyellow:SetScript("OnLeave", nil)
	Vibrant.frames.main.downblue:SetScript("OnLeave", nil)
	Vibrant.frames.main.leftred:SetScript("OnLeave", nil)
	Vibrant.frames.main.playbtn:SetScript("OnLeave", nil)
	Vibrant.frames.main.delbtn:SetScript("OnLeave", nil)
	
	Vibrant.frames.main.playbtn.texture:SetAlpha(0)
	Vibrant.frames.main.delbtn.texture:SetAlpha(0)
end


--[[                  ]]
--[[ ButtonsClickable ]]
--[[                  ]]

function Vibrant:ButtonsClickable()
	Vibrant.frames.main.upgreen:SetScript("OnClick", Vibrant.PressedBtnUG)
	Vibrant.frames.main.rightyellow:SetScript("OnClick", Vibrant.PressedBtnRY)
	Vibrant.frames.main.downblue:SetScript("OnClick", Vibrant.PressedBtnDB)
	Vibrant.frames.main.leftred:SetScript("OnClick", Vibrant.PressedBtnLR)
	Vibrant.frames.main.playbtn:SetScript("OnClick", Vibrant.PressedBtnPlay)
	Vibrant.frames.main.delbtn:SetScript("OnClick", Vibrant.PressedBtnDel)

	Vibrant.frames.main.upgreen:SetScript("OnEnter", function () Vibrant.frames.main.upgreen.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\green_on") end)
	Vibrant.frames.main.rightyellow:SetScript("OnEnter", function () Vibrant.frames.main.rightyellow.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\yellow_on") end)
	Vibrant.frames.main.downblue:SetScript("OnEnter", function () Vibrant.frames.main.downblue.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\blue_on") end)
	Vibrant.frames.main.leftred:SetScript("OnEnter", function () Vibrant.frames.main.leftred.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\red_on") end)
	Vibrant.frames.main.playbtn:SetScript("OnEnter", function () Vibrant.frames.main.playbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\play_on") end)
	Vibrant.frames.main.delbtn:SetScript("OnEnter", function () Vibrant.frames.main.delbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\del_on") end)

	Vibrant.frames.main.upgreen:SetScript("OnLeave", function () Vibrant.frames.main.upgreen.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\green_off") end)
	Vibrant.frames.main.rightyellow:SetScript("OnLeave", function () Vibrant.frames.main.rightyellow.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\yellow_off") end)
	Vibrant.frames.main.downblue:SetScript("OnLeave", function () Vibrant.frames.main.downblue.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\blue_off") end)
	Vibrant.frames.main.leftred:SetScript("OnLeave", function () Vibrant.frames.main.leftred.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\red_off") end)
	Vibrant.frames.main.playbtn:SetScript("OnLeave", function () Vibrant.frames.main.playbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\play_off") end)
	Vibrant.frames.main.delbtn:SetScript("OnLeave", function () Vibrant.frames.main.delbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\del_off") end)
	
	Vibrant.frames.main.playbtn.texture:SetAlpha(1)
	Vibrant.frames.main.delbtn.texture:SetAlpha(1)
	Vibrant.frames.main.playbtn.texture:SetTexture("Interface\\AddOns\\Vibrant\\gfx\\play_off")
end